<template>
  <div class="q-pa-md bg-grey-4">
    <q-table
      :dark="isDark"
      flat bordered
      :rows="rows"
      :columns="columns"
      row-key="_id"
      :loading="tableLoad"
      :visible-columns="visibleColumns"
      :dense="tableDense"
      :pagination="pagination"
      no-data-label="Ничего нет"

      :selected-rows-label="getSelectedString"
      selection="multiple"
      v-model:selected="selected"

      virtual-scroll
      :virtual-scroll-item-size="150"
      :virtual-scroll-sticky-size-start="150"
      :rows-per-page-options="[0]"
      @virtual-scroll="onScroll"
      loading-label="Пожалуйста подождите..."

      class="table-leads"
    >
      <template v-slot:loading>
        <q-inner-loading showing />
      </template>
      <template v-slot:top="props">
        <div class="col-2 q-table__title">{{!basketFlag && 'Лиды' || 'Корзина'}}</div>
        <q-space />
        <UserSelected
            v-if="selected.length"
            :model-select="selectedResponsible.username"
            :model-value="selectedResponsible.username && selectedResponsible.username || ''"
            :label-chip="selectedResponsible.username && selectedResponsible.username || 'Отвественный'"
            color-chip="blue"
            text-color-chip="white"

            @selectUser="selectResponsible"
            class="block mx-4"
        />
        <q-btn v-if="selected.length && basketFlag" label="Восстановить" @click="leadToBasket" color="grey-7" class="mr-2" />
        <q-btn v-if="selected.length && !basketFlag" label="В корзину" @click="leadToBasket" color="grey-7" class="mr-2" />
        <q-btn v-if="selected.length && roleMiddleware(['ADMIN'])" label="Удалить" @click="deleteLead" color="red" class="mr-2" />
        <q-btn flat dense label="темная тема" size="sm" @click="darkStyle" class="mr-4" />
        <q-btn flat dense label="Добавить лид" @click="isNewLeadDialog = true" class="mr-4" />
        <q-btn flat dense :label="basketFlag && 'Лиды' || 'Корзина'" @click="switchLeadToBasket" class="mr-4" />
        <SearchInput @searchResult="searchResult" @clear="clearSearch"/>
        <q-select
          v-model="visibleColumns"
          multiple
          outlined
          dense
          options-dense
          display-value="Колонки"
          emit-value
          map-options
          :options="columns"
          option-value="name"
          style="min-width: 150px"
        >
          <template v-slot:option="{ itemProps, opt, selected, toggleOption }">
            <q-item v-bind="itemProps">
              <q-item-section>
                <q-item-label v-html="opt.label" />
              </q-item-section>
              <q-item-section side>
                <q-toggle :model-value="selected" @update:model-value="toggleOption(opt)" />
              </q-item-section>
            </q-item>
          </template>
        </q-select>

        <q-btn
          flat round dense
          :icon="tableDense ? 'zoom_in' : 'zoom_out'"
          @click="tableDense = !tableDense"
          class="q-ml-md"
        />
        <q-btn
          flat round dense
          :icon="props.inFullscreen ? 'fullscreen_exit' : 'fullscreen'"
          @click="props.toggleFullscreen"
          class="q-ml-md"
        />
      </template>
      <template v-slot:header-cell="props">
        <q-th>
          <div v-if="props.col.name !== 'createdAt'" class="flex justify-center">
            <q-select
              v-model="sortModel[props.col.name]"
              use-input
              multiple
              dense
              row-key="name"
              :label="props.col.label"
              :options="options"
              @focus.prevent="distinctLead(props.col.name)"
              @filter="filterDistinct"
              map-options
              style="width: 100px"
              use-chips
            >
              <template v-slot:no-option>
                <q-item>
                  <q-item-section class="text-grey">
                    Нет результатов
                  </q-item-section>
                </q-item>
              </template>
            </q-select>
          </div>
          <q-chip v-if="props.col.name === 'createdAt'" :removable="!!sortModel[props.col.name]" :label="sortModel[props.col.name] || 'Выбрать дату'">
            <q-menu>
              <q-date :locale="myLocale" :model-value="new Date()" v-model="sortModel[props.col.name]" color="info" />
            </q-menu>
          </q-chip>
        </q-th>
      </template>
      <template v-slot:body="props">
        <q-tr @mouseup="(event) => isMobile && showContextMenu(event, props.row)" @contextmenu.prevent="(event) => showContextMenu(event, props.row)" :props="props">
          <q-td key="selection">
            <q-checkbox v-model="props.selected" />
          </q-td>
          <q-td key="name" :props="props" style="max-width: 100px">
            <p class="truncate w-full cursor-pointer">
              {{props.row.name}}
              <q-tooltip>{{props.row.name}}</q-tooltip>
            </p>
            <q-popup-edit v-model="props.row.name" v-slot="scope" >
              <q-input v-model="scope.value" dense autofocus counter />
              <q-btn class="float-right" label="Сохранить" color="green" size="sm" @click="useUpdateLead({_id: props.row._id, key: 'name', value: scope.value})"/>
            </q-popup-edit>
          </q-td>
          <q-td key="responsible" :props="props">
            <q-chip
              clickable
              :label="props.row.responsible?.username || 'Указать'"
              :color="props.row.responsible?.username && 'primary' || 'red'"
              :outline="!props.row.responsible?.username"
              text-color="white"
            >
              <q-menu anchor="center middle"
                      self="center middle"
                      max-height="250px"
                      class="p-2"
              >
                <q-select
                  v-model="props.row.responsible"
                  dense
                  row-key="username"
                  option-label="username"
                  :label="props.row.responsible?.username"
                  :options="options"
                  @filter="filterUsers"
                  map-options
                  use-input
                  autofocus
                  clearable
                  @clear="col"
                  @remove="col"
                >
                  <template v-slot:option="{ itemProps, opt, selected, toggleOption }">
                    <q-item v-bind="itemProps">
                      <q-item-section
                          @click="useUpdateLead({_id: props.row._id, key: 'responsible', value: opt.username === 'Снять' && {username: '', _id: ''} || opt})"
                          @update:model-value="selected"
                      >
                        <q-item-label v-html="opt.username" />
                      </q-item-section>
                    </q-item>
                  </template>
                  <template v-slot:no-option>
                    <q-item>
                      <q-item-section class="text-grey">
                        Нет результатов
                      </q-item-section>
                    </q-item>
                  </template>
                </q-select>
              </q-menu>
            </q-chip>
          </q-td>
          <q-td key="website" :props="props">
            <div class="text-pre-wrap">{{ props.row.website }}</div>
            <q-popup-edit v-model="props.row.website">
              <q-input v-model="props.row.website" dense autofocus counter />
              <q-btn v-close-popup class="float-right" label="Сохранить" color="green" size="sm" @click="useUpdateLead({_id: props.row._id, key: 'website', value: props.row.website})"/>
            </q-popup-edit>
          </q-td>
          <q-td key="phone" :props="props">
            {{ props.row.phone + ' ' + (props.row.email || '') }}
          </q-td>
<!--          <q-td key="article" :props="props">-->
<!--            {{ props.row?.article?.value }}-->
<!--          </q-td>-->
          <q-td key="city" :props="props">{{ props.row.city }}</q-td>
          <q-td key="status" :props="props" v-slot="el">
            <q-chip @click="getStatus" clickable :label="props.row.status && props.row.status.name || 'Указать'" :style="{backgroundColor: props.row.status?.color, color: '#fff'}">
              <q-menu anchor="center middle"
                      self="center middle"
                      max-height="250px"
                      auto-close
              >
                <q-list style="min-width: 100px">
                  <q-item v-for="(item, index_status) in status">
                    <q-item-section clickable class="cursor-pointer" @click="selectStatus(props.row._id, item)">
                      <q-chip :label="item.name" :style="{backgroundColor: item.color, color: '#fff'}" />
                    </q-item-section>
                  </q-item>
                </q-list>
              </q-menu>
            </q-chip>
          </q-td>
          <q-td key="task" :props="props">
            <span v-for="task in props.row.task" v-show="task.statusTask" class="flex column">
              <q-badge class="my-1"
                       :label="`${task.task} ${formattedDate(task.taskDate, false)} ${task.taskHour}`"
                       :color="task.statusTask &&
                          useCompareDate({date: task.taskDate, time: task.taskHour}) && 'green' || 'red'
                        "
              />
            </span>
          </q-td>
          <q-td key="budget" :props="props">{{ props.row.budget }}</q-td>
          <q-td key="prepay" :props="props">{{ props.row.prepay }}</q-td>
          <q-td key="debt" :props="props">{{ props.row.debt }}</q-td>
          <q-td key="updatedAt" :props="props">{{ formattedDate(props.row.updatedAt, true) }}</q-td>
          <q-td key="createdAt" :props="props">{{ formattedDate(props.row.createdAt, true) }}</q-td>
        </q-tr>
      </template>
      <template v-slot:bottom="props">
        <div class="grid grid-cols-2 w-full">
          <div>Пользователей онлайн: <q-badge :label="userOnline" color="grey"/></div>
          <div class="ml-auto"><span v-if="selected.length">{{`Выделено: ${selected.length} / Всего `}}</span>{{rows.length}} из {{total}}</div>
        </div>
      </template>
    </q-table>
    <Modal v-if="isNewLeadDialog" @close="isNewLeadDialog = false" no-border background-color="white">
      <template v-slot:body>
        <div class="q-pa-md">
          <div class="text-black text-h5 mb-4 opacity-80">Новый ЛИД</div>
          <q-input class="my-2" standout v-model="leadForm.name" label="Имя" stack-label />
          <q-input class="my-2" standout v-model="leadForm.email" label="Email" stack-label />
          <q-input class="my-2" standout v-model="leadForm.phone" label="Телефон" stack-label />
          <q-input class="my-2" standout v-model="leadForm.website" label="Сайт откуда лид" stack-label />
          <q-btn color="primary" label="Создать" @click="addNewLead" :loading="loadAddLeadButton" />
        </div>
      </template>
    </Modal>
  </div>
  <div v-if="contextMenuVisible"
       v-click-outside="hideContextMenu"
       class="context-menu column md shadow p-1"
       style="display: flex!important;"
       :style="{ top: `${contextMenuTop}px`, left: `${contextMenuLeft}px`}"
  >
    <q-btn color="white">
      <router-link :to="{name: 'Lead', params: {id: selected[0]._id}}" target="_blank">
        Открыть
      </router-link>
    </q-btn>
    <q-btn v-if="selected.length && roleMiddleware(['ADMIN'])" label="Удалить" @click="deleteLead" color="red" />
  </div>
</template>

<script>
import {ref, onMounted, watch, nextTick, computed} from 'vue'
import { io } from "socket.io-client";
import Modal from "../../components/Modal.vue";
import LoadsSpinner from "../../components/Loads-spinner.vue";
import api from "../../API/api";
import FullModal from "../../components/FullModal.vue";
import {useStore} from "vuex";
import formattedDate from "../../utils/formatDate";
import {useRouter} from "vue-router";
import {useUpdateLead} from "../../components/useUpdateLead";
import {useCompareDate} from "../../components/useCompareDate";
import {roleMiddleware} from "../../components/roleMiddleware";
import {stream} from "../../API/stream";
import store from "../../vuex/store";
import UserSelected from "../../components/UserSelected.vue";
import SearchInput from "./Search-Input.vue";

let stringOptions = [].reduce((acc, opt) => {
  for (let i = 1; i <= 5; i++) {
    acc.push(opt + ' ' + i)
  }
  return acc
}, [])
export default {
  components: {SearchInput, UserSelected, FullModal, LoadsSpinner, Modal},
  setup () {
    const store = useStore()
    const router = useRouter();
    const user = store.state.user
    const tableLoad = ref(true)
    const tableDense = ref(false)
    const sortModel = ref({})

    const columns = ref([
      {
        name: 'name',
        label: 'Название',
        align: 'left',
      },
      { name: 'responsible', label: 'Отвественный', align: 'center', field: 'calories' },
      { name: 'website', label: 'Сайт', align: 'center',},
      { name: 'phone', label: 'Телефон', align: 'center', },
      // { name: 'article', label: 'Статья', align: 'center', },
      { name: 'city', label: 'Город', align: 'center', },
      { name: 'status', label: 'Статус', align: 'center', },
      { name: 'task', label: 'Задача', align: 'center',},
      { name: 'budget', label: 'Бюджет', align: 'center',},
      { name: 'prepay', label: 'Предоплата', align: 'center',},
      { name: 'debt', label: 'Долг', align: 'center',},
      { name: 'updatedAt', label: 'Изменен', align: 'center',},
      { name: 'createdAt', label: 'Создан', align: 'center',}
    ])

    const selected = ref([])
    function getSelectedString () {
      return selected.value.length === 0 ? '' : `${selected.value.length} record${selected.value.length > 1 ? 's' : ''} selected of ${rows.length}`
    }

    const visibleColumns = ref(localStorage.visibleColumns &&  JSON.parse(localStorage.visibleColumns) || [
      'name',
      'responsible',
      'website',
      'phone',
      // 'article',
      'city',
      'status',
      'task',
      'budget',
      'prepay',
      'debt',
      'updatedAt',
      'createdAt',
    ])
    watch(visibleColumns, (val) => {
      localStorage.setItem('visibleColumns', JSON.stringify(val))
    })
    const rows = ref([])
    const total = ref(0)

    const model = ref(null)
    const options = ref(stringOptions)


    const basketFlag = ref(false)
    const limit = ref(30)
    const skip = ref(0)
    const isBlackBlockUser = ref(false)
    async function getLeads () {
      tableLoad.value = true
      await api.getLeads({limit: limit.value, skip: skip.value})
        .then(res => {
          if (res.data.status) {

            // выводим статью из поля fields в колонку таблицы "Статья"
            res.data.leads.filter(el => {
              // const obj = el.fields.filter(e => e._id === '6446252ca93911da46a1eaf4')
              // el.article = obj[0].values
              if (user.leadsman && user.leadsman.length) user.leadsman.indexOf(el.generate)
            })

            skip.value += limit.value
            rows.value.push(...res.data.leads)
            total.value = res.data.total
            tableLoad.value = false
          } else {
            res.data.filter(el => {
              // console.log(el)
              // const obj = el.fields.filter(e => e._id === '6446252ca93911da46a1eaf4')
              // el.article = obj[0].values
              if (user.leadsman && user.leadsman.length) user.leadsman.indexOf(el.generate)
            })

            skip.value += limit.value
            rows.value.push(...res.data)
            total.value = res.data.total
            tableLoad.value = false
          }
        })
        .catch(err => {
          console.log(123)
          console.log(err)
          // er.response.data.message === 'Пользователь не авторизован' && router.replace({name: 'Login'})
          // er.response.data.message === 'Пользователь заблокирован' && router.replace({name: 'Login'})
        })
    }
    getLeads()

    const nextPage = ref(2)
    const lastPage = Math.ceil(1000)
    function onScroll ({ to, ref }) {
      const lastIndex = rows.value.length - 1
      if (!isSort.value && tableLoad.value !== true && nextPage.value < lastPage && to === lastIndex) {
        tableLoad.value = true
        nextTick(async () => {
          if (basketFlag.value) {
            await getBasket().then(() => {
              ref.refresh()
              tableLoad.value = false
            })
          } else {
            if (rows.value.length > 29) {
              await getLeads().then(() => {
                ref.refresh()
              })
            }
            tableLoad.value = false
          }
        })
      }
    }

    const status = ref([])
    async function getStatus () {
      await api.getStatusLeads()
        .then(res => {
          status.value = [...res.data.statusLeads]
        })
    }
    async function selectStatus (lead_id, status) {
      await api.selectStatusLead({lead_id, status_id: status._id})
        .then(() => {
          rows.value.filter(el => {
            if (el._id === lead_id) el.status = status
          })
        })
    }
    const users = ref([])
    async function getUsers () {
      await api.getUsers()
        .then(res => {
          users.value = [...res.data.users]
        })
    }

    const selectedResponsible = ref({})
    async function selectResponsible (user) {
      selectedResponsible.value = user
      const select_id = selected.value.map(el => el._id)
      await api.selectResponsibleLead({lead_id: select_id, user_id: user._id, username: user.username})
      rows.value.forEach(el => {
        if (select_id.includes(el._id)) {
          el.responsible.username = user.username
          el.responsible._id = user._id
        }
      })
    }

    const isSort = ref(false)
    function distinctLead (el) {
      model.value = el
    }
    watch(sortModel.value, (val) => {
      const entries = Object.entries(val);
      let notEmptySortValue = 0
      for (let [key, value] of entries) {
        if (value.length) {
          notEmptySortValue++
          isSort.value = true
        } else {
          skip.value = 0
        }
      }
      if (notEmptySortValue > 0) return selectSort()
      if (notEmptySortValue === 0) {
        rows.value.splice(0, rows.value.length)
        isSort.value = false
        return getLeads()
      }

    });
    async function selectSort (col, scope) {
      tableLoad.value = true
      // sortModel.value[col.name] || (sortModel.value[col.name] = [])
      // sortModel.value[col.name].push(scope)
      await api.sortLead({sort: sortModel.value})
        .then(res => {
          // выводим статью из поля fields в колонку таблицы "Статья"
          // res.data.leads.filter(el => {
          //   const obj = el.fields.filter(e => e._id === '6446252ca93911da46a1eaf4')
          //   el.article = obj[0]
          // })
          rows.value.splice(0, rows.value.length)
          rows.value.push(...res.data.leads)
          tableLoad.value = false
        })
    }
    async function filterDistinct (val, update, abort) {
      await api.distinctLead({value: model.value}).then(res => {
        stringOptions = res.data.value
        if (model.value === 'task') stringOptions.unshift('Без задач','Просроченные')
        if (model.value === 'status') stringOptions.unshift('Без статуса')
        update(() => {
          const needle = val.toLocaleLowerCase()
          options.value = stringOptions.filter(v => v && v.toLocaleLowerCase().indexOf(needle) > -1)
        })
      })
      update(() => {
        const needle = val.toLocaleLowerCase()
        options.value = stringOptions.filter(v => v && v.toLocaleLowerCase().indexOf(needle) > -1)
      })
    }
    async function filterUsers (val, update, abort) {
      await api.getUsers().then(res => {
        stringOptions = res.data.users.map(obj => {
          const { username, _id } = obj; // Оставляем только свойства username и _id
          return { username, _id };
        });
        stringOptions.unshift({username: 'Снять'}, {username: user.username, _id: user._id})
      })
      update(() => {
        const needle = val.toLocaleLowerCase()
        options.value = stringOptions.filter(v => v.username.toLocaleLowerCase().indexOf(needle) > -1)
      })
    }

    const leadForm = ref({
      name: '',
      email: '',
      phone: '',
      website: '',
    })
    const isNewLeadDialog = ref(false)
    const loadAddLeadButton = ref(false)
    async function addNewLead () {
      loadAddLeadButton.value = true
      if (user.roles[0] !== 'ADMIN') {
        leadForm.value.responsible = {
          username: user.username,
              _id: user._id
        }
      } else {
        leadForm.value.responsible = {
          username: '',
          _id: ''
        }
      }
      await api.addLead(leadForm.value).then(() => {
        loadAddLeadButton.value = false
        isNewLeadDialog.value = false
      })
    }

    const userOnline = ref(store.state.online_count)
    stream('add lead', rows.value);
    stream('change lead', rows.value);
    stream('leads delete', rows.value);
    stream('user online', userOnline);

    async function deleteLead () {
      const arrGetIdLead = selected.value.map(obj => obj._id)

      await api.deleteLead({data: arrGetIdLead, basket: false})
        .then(() => {
          selected.value = []
        })
    }
    async function leadToBasket () {
      selected.value.forEach(item => {
        useUpdateLead({_id: item._id, key: 'basket', value: !basketFlag.value})
      })
      selected.value = []
    }
    function switchLeadToBasket () {
      basketFlag.value = !basketFlag.value
      rows.value.splice(0, rows.value.length)
      limit.value = 30
      skip.value = 0
    }
    async function getBasket () {
      tableLoad.value = true
      await api.getBasket({limit: limit.value, skip: skip.value})
        .then(res => {
          rows.value.push(...res.data.basket)
          tableLoad.value = false
          skip.value += limit.value
        })
    }

    const isMobile = computed(() => window.innerWidth < 768)
    const contextMenuVisible = ref(false)
    const contextMenuTop = ref(0);
    const contextMenuLeft = ref(0);
    function showContextMenu(event, val) {
      if (isMobile.value) {
        return router.push({name: 'Lead', params: {id: val._id}})
      }
      selected.value = [val]
      event.preventDefault();
      contextMenuTop.value = event.clientY;
      contextMenuLeft.value = event.clientX;
      contextMenuVisible.value = true;
    }
    function hideContextMenu(event) {
      event.preventDefault();
      contextMenuTop.value = 0;
      contextMenuLeft.value = 0;
      contextMenuVisible.value = false;
    }

    function handleMenuItemClick(option) {
      // console.log('Clicked:', option);
    }

    // function settingsLead () {
    //   api.settingsLead({_id: '64fc103fe996520d02d50a3b'}).then(r => console.log(r.data.log))
    // }
    // settingsLead()

    function darkStyle () {
      store.commit('DARK_STYLE')
    }

    function searchResult (el) {
      isSort.value = true
      rows.value = el.lead
    }
    function clearSearch (el) {
      isSort.value = false
      rows.value.splice(0, rows.value.length)
      getLeads()
    }

    return {
      store,
      user,
      isDark: computed(() => store.state.darkStyle),
      isMobile,
      darkStyle,
      useCompareDate,
      roleMiddleware,
      tableLoad,
      tableDense,
      columns,
      visibleColumns,
      rows,
      total,
      basketFlag,
      selected,
      getSelectedString,
      options,
      sortModel,
      filterDistinct,
      filterUsers,
      distinctLead,
      useUpdateLead,
      selectSort,
      status,
      getStatus,
      selectStatus,
      users,
      getUsers,
      selectedResponsible,
      selectResponsible,
      pagination: { rowsPerPage: 0 },
      formattedDate,
      onScroll,
      isNewLeadDialog,
      leadForm,
      loadAddLeadButton,
      addNewLead,
      isSort,

      searchResult,
      clearSearch,

      contextMenuVisible,
      contextMenuTop,
      contextMenuLeft,
      showContextMenu,
      handleMenuItemClick,
      hideContextMenu,

      userOnline,

      deleteLead,
      leadToBasket,
      getBasket,
      switchLeadToBasket,
      col: function (el) {},
      myLocale: {
        /* starting with Sunday */
        days: 'Воскресенье_Понедельник_Вторник_Среда_Четверг_Пятница_Суббота'.split('_'),
        daysShort: 'Вс_Пн_Вт_Ср_Чт_Пт_Сб'.split('_'),
        months: 'Январь_Февраль_Март_Апрель_Май_Июнь_Июль_Август_Сентябрь_Октябрь_Ноябрь_Декабрь'.split('_'),
        monthsShort: 'Янв_Фев_Мар_Апр_Май_Июн_Июл_Авг_Сен_Окт_Ноя_Дек'.split('_'),
        firstDayOfWeek: 1, // 0-6, 0 - Sunday, 1 Monday, ...
        format24h: true,
      }
    }
  }
}
</script>

<style lang="scss">
table {
  color: inherit;
}
.context-menu {
  position: fixed;
  background-color: #f1f1f1;
  z-index: 2000;
}
.table-leads {
  max-height: calc(100vh - 90px);
  .q-table thead  {
    //position: sticky;
    //background-color: white;
    top: 0;
    z-index: 1;
  }
}
.home-wrap {
  p {
    margin-bottom: 0
  }
  width: 100vw;
  height: calc(100vh - 70px);
  .element {
    flex-wrap: nowrap;
    img {
      max-height: 20px;
    }
    .element-control {
      flex-wrap: nowrap;
      opacity: 0;
      transition: all .4s ease-in-out;
      margin-left: auto;
    }
    &:hover {
      .element-control {
        opacity: 1;
      }
    }
  }
}
</style>
